#!/usr/bin/perl

use strict;
use FDN::Common::Config;
use FDN::Web::Array;
use FDN::Adsl::Adhs;
use FDN::Adsl::Ag;
use FDN::Adsl::Basic;

prepare_page_adh(only_for_adh => 1);

my $cid = $sess->{content}->{cid};
my $page = '<table style="max-width: 600px">'."\n<tr><td><h2>Convocations aux assembles gnrales</h2></td></tr></table>\n\n";
my $conv = ensure_convocation($cid);
if ( ! $conv ) {
	$page .= '<div class="error">Erreur interne, contacter le bureau</div>'."\n</div>";
	eject_page_adh($page);
	exit(0);
}

$page .= "<table style=\"max-width: 600px\">\n";
#.
#	"<tr>\n".
#		"\t<th>Anne</th>\n".
#		"\t<th>Exercice</th>\n".
#		"\t<th>Date</th>\n".
#		"\t<th>Droit de vote</th>\n".
#		"\t<th>Convocation</th>\n".
#		"\t<th>Prsence</th>\n".
#		"\t<th>Compte rendu</th>\n".
#		"\t<th></th>\n".
#	"</tr>\n";

my $annees = Config_Key('adsl/adhs/ag.cfg', 'ag', '@annees');
for my $annee ( @$annees ) {
	my $cfg = Config_Section('adsl/adhs/ag.cfg', 'ag-'.$annee);
	my $exercice = $annee - 1;
	if ( $cfg->{'status'} eq 'new' ) {
		$page .= "<tr><td colspan=\"2\" width=\"600px\"><h5>Assemble gnrale $annee</h5></td><tr>\n".
			 "<tr><td>Portant sur l'exercice $exercice</td><td>Date : N/A </td></tr>\n".
			 "<tr><td>Droit de vote : N/A</td><td>Convocation : N/A</td></tr>\n".
			 "<tr><td>Prsence : N/A</td>     <td>Compte rendu : N/A</td></tr>\n".
			 "<tr><td></td></tr>\n".
			"</tr>\n";
		next;
	}
	my $date = $cfg->{'date'};
	my ( $forme, $pres, $proc ) = split_convocation($cid,$annee);
	my $repre = affiche_convocation_procuration($cid, $annee);
	my $vote = droit_de_vote($cid, $date, 'vote');
	$vote = $vote ? 'Oui' : 'Non';
	if ( $cfg->{'status'} eq 'open' ) {
		$page .= "<tr><td colspan=\"2\" width=\"600px\"><h5>Assemble gnrale $annee</h5></td><tr>\n".
			 "<tr><td>Portant sur l'exercice $exercice</td><td>Date : $date </td></tr>\n".
			 "<tr><td>Droit de vote : $vote</td><td>Convocation : $forme</td></tr>\n".
			 "<tr><td>Prsence : $repre</td>     <td>Compte rendu : N/A</td></tr>\n".
			 '<tr><td colspan="2"><a href="adh-aglist.cgi?sess=%%sess%%&annee='.$annee.'">Liste des procurations</a></td></tr>'."\n".
			 '<tr><td colspan="2"><a href="adh-agedit.cgi?sess=%%sess%%&annee='.$annee.'">Modifier</a></td></tr>'."\n".
			"</tr>\n";
		next;
	}

        my $base = Config_Key('adsl/global.cfg','dirs','stockpdf');
	my $dir = 'adhacc-'.$cid;

	my $doc = 'ag'.$annee.'.pdf';
	my $pdf;
        if ( -f $base.'/'.$dir.'/'.$doc) {
                $pdf = "<a href=\"print-doc.cgi?sess=%%sess%%&dir=$dir&type=access&doc=$doc\">Convocation</a>";
        } else {
		$pdf = "Fichier $doc indisponible";
	}

	if ( $cfg->{'status'} eq 'convoc' ) {
		$page .= "<tr><td colspan=\"2\" width=\"600px\"><h5>Assemble gnrale $annee</h5></td><tr>\n".
			 "<tr><td>Portant sur l'exercice $exercice</td><td>Date : $date </td></tr>\n".
			 "<tr><td>Droit de vote : $vote</td><td>Convocation : $pdf</td></tr>\n".
			 "<tr><td>Prsence : $repre</td>     <td>Compte rendu : N/A</td></tr>\n".
			 '<tr><td colspan="2"><a href="adh-aglist.cgi?sess=%%sess%%&annee='.$annee.'">Liste des procurations</a></td></tr>'."\n".
			 '<tr><td colspan="2"><a href="adh-agedit.cgi?sess=%%sess%%&annee='.$annee.'">Modifier</a></td></tr>'."\n".
			"</tr>\n";
		next;
	}

	if ( $cfg->{'status'} eq 'close' ) {
		$page .= "<tr><td colspan=\"2\" width=\"600px\"><h5>Assemble gnrale $annee</h5></td><tr>\n".
			 "<tr><td>Portant sur l'exercice $exercice</td><td>Date : $date </td></tr>\n".
			 "<tr><td>Droit de vote : $vote</td><td>Convocation : $pdf</td></tr>\n".
			 "<tr><td>Prsence : $repre</td>     <td>Compte rendu : N/A</td></tr>\n".
			 '<tr><td colspan="2"><a href="adh-aglist.cgi?sess=%%sess%%&annee='.$annee.'">Liste des procurations</a></td></tr>'."\n".
			"</tr>\n";
		next;
	}
	if ( $cfg->{'status'} eq 'old' ) {
		$page .= "<tr><td colspan=\"2\" width=\"600px\"><h5>Assemble gnrale $annee</h5></td><tr>\n".
			 "<tr><td>Portant sur l'exercice $exercice</td><td>Date : $date </td></tr>\n".
			 "<tr><td>Droit de vote : $vote</td><td>Convocation : $pdf</td></tr>\n".
			 '<tr><td>Prsence : '.$repre.'</td>     <td>Compte rendu : <a href="'.$cfg->{'link'}.'">Disponible</a>'."</td></tr>\n".
			 '<tr><td colspan="2"><a href="adh-aglist.cgi?sess=%%sess%%&annee='.$annee.'">Liste des procurations</a></td></tr>'."\n".
			"</tr>\n";
		next;
	}
	$page .= '<tr><td colspan="2"><div class="error">Les informations connues pour '.$annee.' sont invalides. Je ne sais pas afficher ca. Contacter le bureau.</div></td></tr>'."\n";
}

$page .= "</table>\n";
$page .= "<table style=\"max-width: 600px\"><tr><td><p>Cliquez sur le lien <strong>Modifier</strong> de la prochaine AG pour indiquer si vous venez, et sinon,  qui vous voulez donner procuration. Si vous souhaitez donner procuration  quelqu'un qui n'est pas adhrent, merci de contacter le bureau, cette procuration sera traite  la main.</p>\n";

$page .= "<h4>Lgende</h4>\n".
	"<p><strong>Droit de vote</strong> indique si vous avez, ou pas, le droit de vote pour cette Assemble Gnrale (le droit de vote est acquis aprs un an rvolu d'adhsion  l'association).</p>\n".
	"<p><strong>Papier</strong> vous recevez la convocation par courier postal. Un fichier PDF est galement disponible ici, depuis le jour o les couriers sont partis par la poste, et aussi longtemps que les archives de l'association ne sont pas endomages. La convocation reste disponible aprs l'AG.</p>\n".
	"<p><strong>Pdf</strong> vous n'avez que la convocation PDF disponible ici, pas de courier papier.</p>\n";

$page .= '</td></tr></table>';

eject_page_adh($page);


