#!/usr/bin/perl

use strict;
use FDN::Common::Config;
use FDN::Web::Array;
use FDN::Adsl::Adhs;
use FDN::Adsl::Ag;
use FDN::Adsl::Basic;

prepare_page_adh(only_for_adh => 1);

my $annee = $vars->{'annee'};
my $cfg = Config_Section('adsl/adhs/ag.cfg', 'ag-'.$annee);

if ( ! $cfg || $cfg->{'status'} =~ /^(new|close|old)/ ) {
	my $page = '<div style="width: 600px"><div class="error">Invalide</div></div>';
	eject_page_adh($page);
	exit(0);
}
my $date = $cfg->{'date'};

my $present = '<div style="width: 600px">'."\n<h2>Liste des personnes qui seront presentes pour l'AGO $annee</h2>\n\n";
$present .= "<table>\n";
$present .= "<tr><th>Qui...</th><th>droit de vote...</th></tr>\n";

my $page = '<div style="width: 600px">'."\n<h2>Liste des procurations pour l'AGO $annee</h2>\n\n";
my $exercice = $annee - 1;
$page .= "<p>Assemble gnrale portant sur l'exercie $exercice</p>\n";

$page .= "<table>\n";
$page .= "<tr><th>Qui...</th><th>droit de vote...</th><th>est reprsent par...</th></td>\n";
my $convs = [ tous_convocation() ];
for my $conv ( @$convs ) {
	my $cid = $conv->{'CLIENT_ID'};
	my ( $forme, $pres, $proc ) = split_convocation($cid, $annee);
	my $client = client_par_id($cid);
	my $name = $client->{'CLIENT_NOM'}.' ('.$client->{'CLIENT_NUMADH'}.')';
	my $vote = droit_de_vote($cid, $date, 'vote');
	$vote = $vote ? 'Oui' : 'Non';
	if ( ! $proc ) {
		if ( $pres eq 'oui' ) {
			$present .= "<tr><td>$name</td><td>$vote</td></tr>\n"
		}
		next;
	}
	my $repre = affiche_convocation_procuration($cid, $annee);


	$page .= "<tr><td>$name</td><td>$vote</td><td>$repre</td>\n";
}

if ( $cfg->{'@procu'} ) {
	for my $manuelle ( @{$cfg->{'@procu'}} ) {
		next if $manuelle !~ /(\d+),(.*)$/;
		my ( $num, $nom ) = ( $1, $2 );
		my $client = client_par_numadh($num);
		if ( ! $client ) {
			$page .= '<tr><td colspan="3">PROCURATION MANUELLE INVALIDE</td></tr>'."\n";
			next;
		}
		my $cid = $client->{'CLIENT_ID'};
		my $name = $client->{'CLIENT_NOM'}.' ('.$client->{'CLIENT_NUMADH'}.')';
		my $vote = droit_de_vote($cid, $date, 'vote');
		$vote = $vote ? 'Oui' : 'Non';
		$page .= "<tr><td>$name</td><td>$vote</td><td>$nom (procuration manuelle auprs du bureau)</td>\n";
	}
}
$page .= "</table>\n";
$page .= '</div>';

$present .= "</table>\n";
$present .= "</dir>\n";

eject_page_adh($present.$page);


