#!/usr/bin/perl

use strict;
use FDN::Web::Array;
use FDN::Web::Forms;
use FDN::Common::Logger;
use FDN::Common::Modules;
use FDN::Adsl::Adhs;
use FDN::Adsl::Basic;
use FDN::Adsl::Infos;

prepare_page_adh();
my $page = '';
my $cid = $sess->{content}->{cid};
my $lid = $vars->{'lid'};

my $ligne = ligne_par_id($lid);
if ( ! defined $ligne ) {
	$page = "<p>Il ne faut pas tricher</p>";
	goto EJECT;
}

if ( $ligne->{'CLIENT_ID'} ne $cid ) {
	$page = "<p>Petit curieux va</p>";
	goto EJECT;
}

$page = "<p>Pas de changement de dbit ou d'option possible pour le moment</p>";
goto EJECT;

my $client = client_par_id($cid);
my $tarif = $client->{'CLIENT_TYPE'};
my $tel = $ligne->{'LIGNE_TEL'};

#$page = "<p>On modifie la ligne $lid</p>";

if ( $ligne->{'LIGNE_OPT'} =~ 'Liazo' ) {
	$page .= "<p>On ne sait pas encore changer de dbit sur une ligne dj chez Liazo.</p>";
	goto EJECT;
}

if ( $vars->{do} ne 'yes' ) {
	my $rejets;
	my $form = make_form_offre($tel, \$rejets);
	if ( ! defined $form ) {
		goto EJECT;
	}
	$page .= affiche_form($form,$vars);
	$page .= "<div class=\"rejets\"><p>Il y certains dbit pour lesquels vous n'tes pas ligibles.".
		 " Pour votre information, voil les raisons qui nous ont t donnes. Si certaines vous".
		 " semblent fausses, n'hsitez pas  nous contacter.</p>$rejets</div>";
	goto EJECT;
}

# Le nouveau dbit:
my $debit = $vars->{'debit'};
$debit =~ s/opt\d$//;
$debit =~ s/Liazo.*//;
my $debid = debit_id_par_debit($debit);

#if ( $debid == $ligne->{'DEBIT_ID'} ) {
#	$page .= "<p>Dbit inchang, on arrte les frais.</p>";
#	goto EJECT;
#}
#$page .= "<p>Nouveau dbit: $debid ($debit).</p>";

# La nouvelle option:
my $option = $vars->{'debit'};
$option =~ s/^\d+[kM]//;
$option =~ s/opt/option/;

#if ( $option ne $ligne->{'LIGNE_OPT'} ) {
#	$page .= "<p>On ne sait pas changer l'option.</p>";
#	goto EJECT;
#}
$page .= "<p>Nouvelle option: $option.</p>";

# Le nouveau tarif

my $prix = prix_id_par_debit_id_type_option($debid,$client->{'CLIENT_TYPE'},$option);
#$page .= "<p>Nouveau tarif: $prix.</p>";

# Remonter l'ancien deploiement

my $dpl = deploiement_par_ligne_id($lid);
if ( ! defined $dpl ) {
	$page .= "<p>Pas de dploiement.</p>";
	goto EJECT;
}
#$page .= "<p>Dploiement OK.</p>";

# Remonter le mandat associ
#
#my $mandat = mandat_par_deploiement_id($dpl->{'DEPLOIEMENT_ID'});
#if ( ! defined $mandat ) {
#	$page .= "<p>Pas de mandat.</p>";
#	goto EJECT;
#}
#my $mid = $mandat->{'MANDAT_ID'};
#$page .= "<p>Mandat OK.</p>";

my $idld = $ligne->{'LIGNE_IDLD'};
#if ( ! defined $idld || ! $idld ) {
#	$page .= "<p>Pas d'idld.</p>";
#	goto EJECT;
#}
#$page .= "<p>Identifiant LD: $idld</p>";

## Cloner le mandat
#
#use FDN::Adsl::Mandat;
#my $nmid = clone_mandat($mid);
#if ( ! defined $nmid ) {
#	$page .= "<p>Echec clonage mandat.</p>";
#	goto EJECT;
#}
#$page .= "<p>Mandat clon.</p>";

# Crer un nouveau dploiement

new_info_ligne($lid,'inline','Modification de dbit',
	'On lance la modification du dbit de la ligne. Nouveau dploiement.');
use FDN::Adsl::Souscription qw(creation_deploiement_ligne);
#my $ndid = creation_deploiement_ligne($lid, $nmid);
my $ndid = creation_deploiement_ligne($lid);

# Les infos pour la tache:
# - ligneid: $lid
# - debit: $debit
# - option: $option
# - tarif: $prix
# - deplid: $ndid
# - idld: $idld

conduse('FDN::Sql::Workflow::Run');
workflow_select_db('adsl');
workflow_select_config('adsl/wf.cfg');

my $task_vars = {
	'ligneid' => $lid,
	'debit' => $debit,
	'option' => $option,
	'tarif' => $prix,
	'deplid' => $ndid,
	'idld' => $idld,
	'type' => 'liazo',
};

my $tid = launch_task('change-adslL',$task_vars);
if ( ! $tid ) {
	$page .= "<p class=\"error\">La demande a choue,  la suite d'une erreur technique
		chez FDN. R-essayer n'apporterait rien. Prenez contact avec le bureau de
		l'association pour qu'il traite votre demande.</p>";
	new_info_ligne($lid,'inline','ECHEC','Echec de lancement de la tache de changement de '.
		'dbit de la ligne ADSL.');
} else {
	$page .= "<p>Votre demande est prise en compte, vous recevrez rgulirement des informations
		par mail.</p>";
}

EJECT:
if ( $page eq '' ) {
	$page = "<p class=\"error\">La demande a choue,  la suite d'une erreur technique
	                chez FDN. R-essayer n'apporterait rien. Prenez contact avec le bureau de
	                l'association pour qu'il traite votre demande.</p>";
}

eject_page_adh($page);

sub make_form_offre($$) {
	my ( $tel, $rej ) = @_;
	conduse('FDN::Adsl::Basic');
	conduse('FDN::Adsl::Souscription');
	conduse('FDN::Adsl::SelL');
	conduse('FDN::Adsl::Utils');
	my $tarifs = $FDN::Adsl::Souscription::tarifs;
	my @offres = @$FDN::Adsl::Souscription::offres;
	my $cfg = 'adsl/adhs/adh.cfg';
	my $form = form_read ( $cfg, 'chadsl' );
	my $elig = eligibilite($tel,0,\@offres);
	if ( $elig->{etat} == 1 ) {
		$page .= "<p>Une erreur technique sur le serveur de Liazo ou sur le serveur ".
			   "de France Tlcom nous met dans ".
			   "l'impossibilit de tester l'ligilit de votre ligne. Merci de ".
			   "ressayer plus tard.</p>\n".
			   "<p>Le texte des messages d'erreur:</p>\n";
		for my $m ( @{$elig->{'message'}} ) {
			$page .= "<p>".$m."</p>\n";
		}
		return undef;
	}
	if ( $elig->{etat} == 2 ) {
		$page = "Une erreur technique chez FDN empche de poursuivre votre inscription";
		return undef;
	}
	if ( $elig->{etat} == 3 ) {
		$page = "<p>Il y a un problme avec le numro de tlphone que vous avez saisi. Comme vous n'avez pas saisi de numro de tlphone, c'est un problme chez FDN. Merci de signaler l'incident au bureau de l'association.</p>\n";
		for my $m ( @{$elig->{'message'}} ) {
			$page .= "<p>".$m."</p>\n";
		}
		return undef;
	}
	if ( $elig->{etat} ) {
		$page = "<p>Une erreur technique GRAVE chez FDN empche de traiter votre demande. Merci de ".
			   "transmettre l'information a FDN.</p>";
		return undef;
	}
	my $rejets;
	my $debits = 0;
	for my $d ( @$FDN::Adsl::Souscription::offres ) {
		my $option = $d;
		my $debit = $d;
		if ( ! defined $elig ||
		     ! defined $elig->{'offres'} ||
		     ! defined $elig->{'offres'}->{$d} ||
		     ! $elig->{'offres'}->{$d}->{'faisable'} ) {
			debug "Debit $d pas faisable";
			conduse('FDN::Web::TemplateParse');
			$rejets .= remplace('/usr/share/fdn/templates/adsl/html/rejet-elig.tpl',$elig->{'offres'}->{$d},1);
			next;
		}
		ajoute_champ_config($form,$cfg,'chadsl',$d);
		$debits++;
		$debit =~ s/opt\d$//;
		$debit =~ s/Liazo.*//;
		$option =~ s/^\d+[kM]//;
		$option = $FDN::Adsl::Souscription::options->{$option};
		my $did = debit_id_par_debit($debit);
		debug "Debit: $debit, donne $did; option: $option; tarif: ".$tarif;
		my $prid = prix_id_par_debit_id_type_option($did,$tarif,$option);
		debug "Prix id: $prid";
		my $pr = prix_par_id($prid);
		use Data::Dumper;
		debug "Prix: ".Dumper($pr);
		my $fas;
		my $abo;
		if ( $tarif ne 'entreprise' ) {
			$fas = $pr->{PRIX_FASTTC}.' TTC';
			$abo = $pr->{PRIX_ABOTTC}.' TTC';
		} else {
			$fas = $pr->{PRIX_FASHT}.' HT';
			$abo = $pr->{PRIX_ABOHT}.' HT';
		}
		$fas =~ s/(\d{2}) /.$1&euro; /;
		$abo =~ s/(\d{2}) /.$1&euro; /;
		$form->{byname}->{$d}->{'input_label'}.=" $fas puis $abo par mois";
	}
	if ( ! $debits ) {
		$page = "<p>Il semble que vous ne soyiez pas ligible  un raccordement ADSL. Peut-tre votre ligne est dgroupe totalement ? Il est alors normal que le test choue puisque la ligne n'est plus dans les tables de FT. Essayez avec le numro de tlphone d'un(e) voisin(e) qui n'a pas de dgroupage total. Si votre ligne n'est pas dgroupe totalement, peut-tre que le test de dgroupage est simplement en maintenance. Voil ".
				 "l'ensemble des informations que nous avons obtenu  propos de votre ligne.</p>".
				 $rejets;
		return undef;
	}
	if ( defined $rej ) {
		$$rej = $rejets;
	}
	return $form;
}


