#!/usr/bin/perl

use strict;
use FDN::Common::Config;
use FDN::Common::Logger;
use FDN::Web::Array;
use FDN::Adsl::Adhs;

prepare_page_adh();
my $page = '';
my $maps = Config_Key('adsl/maps.cfg','global','@map');
my $link = Config_Key('adsl/global.cfg','web','link_maps');
my @vals;

for my $m ( @$maps ) {
	my $val = Config_Section('adsl/maps.cfg','map-'.$m);
	if ( ! defined $val ) {
		error "Map not found: $m";
		next;
	}
	$val = {
		'link' => $link,
		'ilink' => 'adh-inmap.cgi',
		'cfg' => $m,
		%$val
	};
	push @vals, $val;
}

$page .= tableau_2d('adsl/adhs/rewrite.tbl','map',\@vals,'Cartographie FDN');

eject_page_adh($page);


