#!/usr/bin/perl

use strict;
use FDN::Web::Forms;
use FDN::Common::Logger;
use FDN::Adsl::Adhs;
use FDN::Adsl::Basic;
use FDN::Adsl::Utils;

prepare_page_adh();
my $page = '';

my $cfg = 'adsl/adhs/adh.cfg';
my $form = form_read ($cfg, 'modadress');

my $client = client_par_id ( $sess->{'content'}->{'cid'} );

if ( $vars->{do} ne 'yes' ) {

    if ( ! defined $form ) {
        $page .= "<p>Echec au chargement du formulaire</p>";
        eject_page_adh($page);
        exit(0);
    }

    my $adresse = adresse_par_id ( $client->{'ADRESSE_ID'} );
    my $vars = {
        'adresse' => $adresse->{'ADRESSE_ADR'},
        'code_postal' => $adresse->{'ADRESSE_CP'},
        'ville' => $adresse->{'ADRESSE_VILLE'},
        'pgp' => $adresse->{'ADRESSE_PGP'},
        'tel' => $adresse->{'ADRESSE_TEL'},
        'fax' => $adresse->{'ADRESSE_FAX'},
        'sess' => $sess->{'name'},
    };

    $page .= "<div style=\"width:300px\">".affiche_form($form, $vars)."</div>";

    eject_page_adh($page);
    exit(0);
}

if ( ! check_transition($form,$vars) ) {
    info 'Formulaire invalide';
    $page .= affiche_form($form,$vars);
    eject_page_adh($page);
    exit(0);
}

set_adresse_adr ( $client->{'ADRESSE_ID'}, $vars->{'adresse'} );
set_adresse_cp ( $client->{'ADRESSE_ID'}, $vars->{'code_postal'} );
set_adresse_ville ( $client->{'ADRESSE_ID'}, $vars->{'ville'} );
if ( defined $vars->{'pgp'} ) {
    set_adresse_pgp ( $client->{'ADRESSE_ID'}, $vars->{'pgp'} );
}
if ( defined $vars->{'tel'} ) {
    set_adresse_tel ( $client->{'ADRESSE_ID'}, $vars->{'tel'} );
}
if ( defined $vars->{'fax'} ) {
    set_adresse_fax ( $client->{'ADRESSE_ID'}, $vars->{'fax'} );
}

prepare_page_adh();

$page .= "<p>Vos coordonnes ont t modifies, comme vous pouvez le constater dans le cartouche Adresse.<p>";

eject_page_adh($page);
exit(0);
