#!/usr/bin/perl

use strict;
use FDN::Web::Array;
use FDN::Web::Forms;
use FDN::Common::Logger;
use FDN::Common::Modules;
use FDN::Adsl::Adhs;
use FDN::Adsl::Basic;
use FDN::Adsl::Infos;
use FDN::Adsl::Utils;
use FDN::Adsl::Souscription;

prepare_page_adh();
my $page = '';
my $cid = $sess->{content}->{cid};

my $client = client_par_id($cid);

my $cfg = 'adsl/adhs/adh.cfg';
my $form = form_read ( $cfg, 'compte' );

my $numadh = $client->{'CLIENT_NUMADH'};
$page = "<h3>Ajout d'un compte bancaire pour l'adh&eacute;rent $numadh.</h3>";

if ( $vars->{do} ne 'yes' ) {
	my $rejets;
	if ( ! defined $form ) {
		$page .= "<p>Echec au chargement du formulaire</p>";
		eject_page_adh($page);
		exit(0);
	}
	$page .= "<div style=\"width:300px\">".affiche_form($form,$vars)."</div>";
	eject_page_adh($page);
	exit(0);
}

if ( ! check_transition($form,$vars) ) {
	info 'Formulaire invalide';
	$page .= affiche_form($form,$vars);
	eject_page_adh($page);
	exit(0);
}

my $plid = creation_prelevement_iban ( $cid, $vars->{'bic'}, $vars->{'iban'}, $vars->{'titulaire'}, $vars->{'banque'});
conduse('FDN::TeX::TeX');
if ( ! set_tex_config('adsl/tex.cfg') ) {
	$page = "<div class=\"error\"><p>Echec a la production du mandat de prelevement en PDF...</p></div>";
	eject_page_adh($page);
	exit(0);
}
my $prel = prelevemt_par_id($plid);
my $client = client_par_id($cid);
my $adresse = adresse_par_id($client->{'ADRESSE_ID'});
#my $access = adhaccess_par_client_id($cid);
my $dir = 'adhacc-'.$cid;
my $prl = make_pdf_file('mandat-sepa',$dir.'/prel'.$plid, {
			'NUMADH'    => $numadh,
			'NOM'	    => $vars->{'titulaire'},
			'ADRESSE'   => $adresse->{'ADRESSE_ADR'},
			'CP'	    => $adresse->{'ADRESSE_CP'},
			'VILLE'     => $adresse->{'ADRESSE_VILLE'},
			'NOMBQ'     => $vars->{'banque'},
			'BIC'	    => $vars->{'bic'},
			'IBAN'	    => $vars->{'iban'},
			'RUM'	    => $prel->{'PRELEVEMT_MANDAT'},
			});

$page = '<div style="width: 600px;">'.
	'<h1>Le compte bancaire a t ajout</h1>'.
	'<p>Le compte est ajout. Il sera activ comme compte principal, et servira pour les prlvements, quand FDN aura reu le mandat sign.</p>'.
	'<p>Le PDF du mandat,  imprimer et  nous retourner sign est disponible dans la <a href="adh-comptes.cgi?sess=%%sess%%">liste des comptes bancaires</a>.</p>'.
	'</div>';

eject_page_adh($page);
exit(0);


