#!/usr/bin/perl

use strict;
use FDN::Web::Array;
use FDN::Common::Logger;
use FDN::Adsl::Adhs;
use FDN::Adsl::Basic;
use FDN::Adsl::Infos;
use FDN::Sql::Workflow::Run;


prepare_page_adh(only_for_adh => 1);
my $page = '';
my $cid = $sess->{content}->{cid};
my $vid = $vars->{'vid'};
my $vpn = vpn_par_id($vid);

if ( $vpn->{'CLIENT_ID'} ne $cid ) {
	eject_page_adh('<p>Petit curieux va !</p>');
	exit(0);
}

if ( $vars->{'confirm'} ne 'ok' ) {
	my $rad = raduser_par_vpn_id($vid);
	$vpn->{'login'} = $rad->{'RADUSER_LOGIN'};
	my $uattrs = [ uattr_par_raduser_id($rad->{'RADUSER_ID'}) ];
	for my $ua ( @$uattrs ) {
		$vpn->{'passwd'} = $ua->{'UATTR_VALUE'} if $ua->{'UATTR_ATTR'} =~ /Passw/;
		$vpn->{'ipaddr'} = $ua->{'UATTR_VALUE'} if $ua->{'UATTR_ATTR'} =~ /Address/;
	}

	my $name = 'VPN '.$vpn->{'ipaddr'};
	if ( $vpn->{'VPN_STATE'} eq 'new' ) {
		$name = 'VPN en attente';
	}

	$page = '<h2>Rsiliation du '.$name.'</h2>'.
		'<p>Si vous confirmez cette rsiliation, elle sera effective tout de suite. Il est encore temps de faire demi-tour.</p>'.
		'<p><a href="/adherents/adh-resvpn.cgi?vid='.$vid.'&confirm=ok&sess=%%sess%%">Confirmation</a></p>';
	eject_page_adh($page);
	exit(0);
}


new_info_vpn($vid,'inline','Resiliation','Resiliation par l adherent en ligne.');
if ( $vpn->{'VPN_STATE'} eq 'new' ) {
	set_vpn_state($vid,'del');
	$page = '<p>La commande de ce VPN a t annule.</p>';
	eject_page_adh($page);
	exit(0);
}

if ( $vpn->{'VPN_STATE'} eq 'del' ) {
	$page = '<p>Ce VPN est dj rsili.</p>';
	eject_page_adh($page);
	exit(0);
}


workflow_select_db('adsl');
workflow_select_config('adsl/wf.cfg');
my $tid = launch_task('resil-vpn',{ vpnid => $vid });
if ( ! $tid ) {
	$page = "<p>Echec. Je n'ai pas pu lancer la tache de rsiliation. Il faut contacter FDN...</p>";
	eject_page_adh($page);
	exit(0);
}
$page = "<p>La rsiliation est lance. Elle sera effective dans quelques minutes."; 
eject_page_adh($page);
exit(0);


