#!/usr/bin/perl

use strict;
use FDN::Common::Config;
use FDN::Common::Logger;
use FDN::Web::Array;
use FDN::Adsl::Adhs;
use FDN::Adsl::Basic;
use FDN::Adsl::Utils;

prepare_page_adh();
my $page = '';
my $cid = $sess->{content}->{cid};
my $users = $sess->{content}->{users};

my $img  = $vars->{'img'};
my $freq = $vars->{'freq'};

my $found = 0;
if ( $img eq 'connexions' ||
     $img eq 'connexions-vpn' ||
     $img eq 'moyenne' ||
     $img eq 'moyenne-vpn' ||
     $img eq 'speciaux/lns01.rrd' ||
     $img eq 'speciaux/lns01-fai-locaux.rrd' ||
     $img eq 'speciaux/lns02.rrd' ||
     $img eq 'speciaux/lns02-fai-locaux.rrd' ||
     $img eq 'speciaux/lns11.rrd' ||
     $img eq 'speciaux/lns11-fai-locaux.rrd' ||
     $img eq 'speciaux/lns22.rrd' ||
     $img eq 'speciaux/lns22-fai-locaux.rrd' ||
     $img eq 'speciaux/vpn1.rrd' ||
     $img eq 'speciaux/vpn2.rrd' ||
     $img eq 'speciaux/option0.rrd' ||
     $img eq 'speciaux/option1.rrd' ||
     $img eq 'speciaux/option3.rrd' ||
     $img eq 'speciaux/option5.rrd' ||
     $img eq 'total.rrd' ||
     $img eq 'total-vpn.rrd' ||
     $img eq 'total-fai-locaux.rrd' ) {
	$found = 1;
}

my $login = $img;
$login =~ s/\.rrd$//;
if ( $users->{$login} ) {	
	$found = 1;
}

my $bornes = {
	'daily'   => [ -86400, -300 ],
	'weekly'  => [ -604800, -1800 ],
	'monthly' => [ -2678400, -7200 ],
	'yearly'  => [ -33053184, -86400 ]
};

my ( $start, $end );
if ( $bornes->{$freq} ) {
	($start, $end) = @{$bornes->{$freq}};
} else {
	$found = 0;
}

if ( ! $found ) {
	error "Acces refus  $img.";
	eject_page_adh("File not found: $img");
	exit(0);
}


# 22:13 < vinci> https://vador.fdn.fr/adherents/adh-statimg.cgi
# 22:13 < vinci> il prends un *fichier* dans /var/www/rrd/images/
# 22:13 < Benjamin-> et il faut qu'il prenne... ?
# 22:13 < vinci> il faudrait qu'il fasse un wget de /img/lammeurl au lieu de image/fichier
# 22:14 < vinci> (avec une auth vu que c'est protg, ou on conf apache)
# 22:14 < vinci> ou faire la mme chose que graph.php
# 22:14 < vinci>  savoir forker un "rrdtool graph" et sortir stdout comme image png 
# 22:14 < vinci> cf le "passthru()" de graph.php, very simple :) 

my $base = Config_Key('adsl/global.cfg','dirs','stockimg');
##my $file = $base.'/'.$img.'_'.$freq.'.png';

my $user = $login;

my $options = "--lower-limit=0";
if ($user eq "total-vpn") {
	#$options = "--logarithmic --units=si";
}

my @filesbandw = qw();
my @filesconn = qw();

my $fh;
my $res;

if ($user eq "total") {
    # Tout l'ADSL
    #@filesbandw = glob("/var/lib/rrd/speciaux/lns[0-9][0-9].rrd");
    @filesbandw = qw(speciaux/lns01 speciaux/lns02 speciaux/lns11 speciaux/lns22);
} elsif ($user eq "total-fai-locaux") {
    # l'ADSL des FAI locaux
    #@filesbandw = glob("/var/lib/rrd/speciaux/lns[0-9][0-9]-fai-locaux.rrd");
    @filesbandw = qw(speciaux/lns01-fai-locaux speciaux/lns02-fai-locaux speciaux/lns11-fai-locaux speciaux/lns22-fai-locaux);
} elsif ($user eq "total-vpn") {
    # Tous les VPNs
    #@filesbandw = glob("/var/lib/rrd/speciaux/vpn[0-9].rrd");
    @filesbandw = qw(speciaux/vpn1 speciaux/vpn2);
} elsif ($user eq "connexions") {
    # Le nombre de connexions ADSL
    #@filesconn = glob("/var/lib/rrd/speciaux/lns[0-9][0-9]-connexions.rrd");
    @filesconn = qw(speciaux/lns01-connexions speciaux/lns02-connexions speciaux/lns11-connexions speciaux/lns22-connexions);
} elsif ($user eq "connexions-vpn") {
    # Le nombre de connexions VPN
    #@filesconn = glob("/var/lib/rrd/speciaux/vpn[0-9]-connexions.rrd");
    @filesconn = qw(speciaux/vpn1-connexions speciaux/vpn2-connexions);
} elsif ($user eq "moyenne") {
    # Debit moyen ADSL
    @filesbandw = qw(speciaux/lns01 speciaux/lns02 speciaux/lns11 speciaux/lns22);
    @filesconn = qw(speciaux/lns01-connexions speciaux/lns02-connexions speciaux/lns11-connexions speciaux/lns22-connexions);
} elsif ($user eq "moyenne-vpn") {
    # Debit moyen VPN
    @filesbandw = qw(speciaux/vpn1 speciaux/vpn2);
    @filesconn = qw(speciaux/vpn1-connexions speciaux/vpn2-connexions);
} else {
    # Un seul utilisateur, juste sa bande passante
    @filesbandw = ($user);
}


my $i;
my $vars = "";

#
# Accumuler les bandes passantes
#
my $in = "0";
my $out = "0";
my $max = "0";
$i = 1;

for my $file (@filesbandw) {
    my $path = "/var/lib/rrd/$file.rrd";
    if ( ! -f $path ) {
        error "File not found: $path";
        eject_page_adh("File not found: $path");
        exit(0);
    }

    $vars .= " DEF:i$i='/var/lib/rrd/$file.rrd':traffic_in:AVERAGE"
            ." DEF:o$i='/var/lib/rrd/$file.rrd':traffic_out:AVERAGE";

    # Avoid unknown values
    $in .= ",i$i,UN,0,i$i,IF,+";
    $out .= ",o$i,UN,0,o$i,IF,+";
    $max .= ",i$i,UN,0,i$i,IF,MAX"
           .",o$i,UN,0,o$i,IF,MAX";

    $i = $i + 1;
}

#
# Accumuler les nombres de connexions
#
my $conn = "0";
$i = 1;

for my $file (@filesconn) {
    my $path = "/var/lib/rrd/$file.rrd";
    if ( ! -f $path ) {
        error "File not found: $path";
        eject_page_adh("File not found: $path");
        exit(0);
    }

    $vars .= " DEF:c$i='/var/lib/rrd/$file.rrd':connexions:AVERAGE";

    # Avoid unknown values
    $conn .= ",c$i,UN,0,c$i,IF,+";

    $i = $i + 1;
}

if ($user eq "connexions" || $user eq "connexions-vpn") {

#
# Graphe pour un nombre de connexions
#

    $res = open $fh, "rrdtool graph -  --imgformat=PNG  --start=$start --end=$end  --title='Nombre de connexions' --rigid  --base=1000  --height=120  --width=500 ".
               "              --alt-autoscale-max  $options --vertical-label='connexions' ".
               $vars.
               " CDEF:conn=$conn ".
	       " AREA:conn#00CF00:'Connexions' ".
               " GPRINT:conn:LAST:' Current\\:%8.2lf %s' ".
               " GPRINT:conn:AVERAGE:'Average\\:%8.2lf %s' ".
               " GPRINT:conn:MAX:'Maximum\\:%8.2lf %s\\n' 2>&1 |";

} elsif ($user eq "moyenne" || $user eq "moyenne-vpn") {

#
# Graphe pour le debit moyen
#

    $res = open $fh, "rrdtool graph -  --imgformat=PNG  --start=$start --end=$end  --title='Moyenne par utilisateur' --rigid  --base=1000  --height=120  --width=500 ".
               "              --alt-autoscale-max  $options --vertical-label='bits per second' ".
               $vars.
               " CDEF:tot_in_bps=$in,8,* ".
               " CDEF:tot_out_bps=$out,8,* ".
               " CDEF:cnx=$conn ".
               " CDEF:moy_in_bps=tot_in_bps,cnx,/ ".
               " CDEF:moy_out_bps=tot_out_bps,cnx,/ ".
               "     AREA:moy_in_bps#00CF00:'Inbound'   ".
               " GPRINT:moy_in_bps:LAST:' Current\\:%8.2lf %s'   ".
               "     GPRINT:moy_in_bps:AVERAGE:'Average\\:%8.2lf %s'   ".
               "     GPRINT:moy_in_bps:MAX:'Maximum\\:%8.2lf %s\\n'   ".
               "     LINE1:moy_out_bps#002A97:'Outbound'   ".
               " GPRINT:moy_out_bps:LAST:'Current\\:%8.2lf %s'   ".
               "     GPRINT:moy_out_bps:AVERAGE:'Average\\:%8.2lf %s'   ".
               "     GPRINT:moy_out_bps:MAX:'Maximum\\:%8.2lf %s\\n' 2>&1 |";


} else {

#
# Graphe pour une bande passante
#

    $res = open $fh, "rrdtool graph -  --imgformat=PNG  --start=$start --end=$end  --title='Traffic for $user' --rigid  --base=1000  --height=120  --width=500 ".
               "              --alt-autoscale-max  $options --vertical-label='bits per second' ".
               $vars.
               "              CDEF:cdefa=$in,8,* ".
               "              CDEF:cdefe=$out,8,* ".
               "              CDEF:mx=$max,8,* VDEF:pct=mx,95,PERCENT ".
               "              AREA:cdefa#00CF00:'Inbound' ".
               "              GPRINT:cdefa:LAST:' Current\\:%8.2lf %s' ".
               "              GPRINT:cdefa:AVERAGE:'Average\\:%8.2lf %s' ".
               "              GPRINT:cdefa:MAX:'Maximum\\:%8.2lf %s' ".
               "              LINE1:cdefe#002A97:'Outbound' ".
               "              GPRINT:cdefe:LAST:'Current\\:%8.2lf %s' ".
               "              GPRINT:cdefe:AVERAGE:'Average\\:%8.2lf %s' ".
               "              GPRINT:cdefe:MAX:'Maximum\\:%8.2lf %s' ".
               "              LINE1:pct#FF0000:'95e    ' ".
               "              GPRINT:pct:' Percent\\:%8.2lf %s'  2>&1 |";
}

if ( ! $res ) {
	error "Failed to start rrdtool";
	eject_page_adh("Failed graph for $user");
	exit(0);
}

send_png_file($fh);
close($fh);

