#!/usr/bin/perl

use strict;
use FDN::Web::Array;
use FDN::Web::Forms;
use FDN::Common::Logger;
use FDN::Common::Modules;
use FDN::Adsl::Adhs;
use FDN::Adsl::Basic;
use FDN::Adsl::Infos;
use FDN::Adsl::Utils;
use FDN::Adsl::Souscription;

prepare_page_adh(only_for_adh => 1);
my $page = '';
my $cid = $sess->{content}->{cid};

my $client = client_par_id($cid);

my $cfg = 'adsl/adhs/adh.cfg';
my $form = form_read ( $cfg, 'subvpn' );

my $numadh = $client->{'CLIENT_NUMADH'};
$page = "<p>Commande d'un VPN pour l'adh&eacute;rent $numadh.</p>";

my $cat = $client->{'CLIENT_TYPE'};
$page .= "<p>Grille tarifaire utilise: $cat</p>";

my $tarif = tarif_par_qui_quoi($cat, 'vpn');
if ( ! defined $tarif ) {
	die "Failed to retrieve TARIF";
}
my $pid = $tarif->{'PRIX_ID'};
my $prix = prix_par_id($pid);
if ( ! $prix ) {
	die "Failed to retrive PRIX_ID $pid";
}
my $ttc = $prix->{'PRIX_ABOTTC'};
$ttc =~ s/(\d\d)$/,$1/;
$page .= "<p>Abonnement mensuel de $ttc Euros TTC par mois.</p>";

if ( $vars->{do} ne 'yes' ) {
	my $rejets;
	if ( ! defined $form ) {
		eject_page_adh($page);
		exit(0);
	}
	$page .= "<div style=\"width:300px\">".affiche_form($form,$vars)."</div>";
	eject_page_adh($page);
	exit(0);
}

if ( ! check_transition($form,$vars) ) {
	info 'Formulaire invalide';
	$page .= affiche_form($form,$vars);
	eject_page_adh($page);
	exit(0);
}

$page .= "<p>L'abonnement VPN est tabli au nom de :".
	$vars->{'nomvpn'}."<br/>".
	$vars->{'adressevpn'}."<br/>".
	$vars->{'cpvpn'}." ".$vars->{'villevpn'}."<br/>".
	$vars->{'emailvpn'}."<br/>".
	$vars->{'pgpvpn'}."</p>";

my $vpnid = creation_vpn(
		$vars->{'nomvpn'},
		$vars->{'adressevpn'},
		$vars->{'cpvpn'},
		$vars->{'villevpn'},
		$vars->{'emailvpn'},
		$vars->{'pgpvpn'},
		$pid,
		$cid);
my $dplid = creation_deploiement_vpn($vpnid);
my $dpl = deploiement_par_id($dplid);
my $dplnum = $dpl->{'DEPLOIEMENT_NUM'};
my $tid = creation_tache_vpn($vars->{'nomvpn'},$vpnid, $dplid);

$page .= "<p>La commande est enregistre. L'accs est en attente de confirmation.</p>".
	"<p>Vous pouvez confirmer en cliquant <a href=\"adh-valvpn.cgi?sess=%%sess%%&vid=$vpnid\">ici</a>, ou y rflchir et revenir valider la commande plus tard.</p>";

eject_page_adh($page);
exit(0);



# La creation


# Attendre confirmation, ou lancer tout de suite ?


