#!/usr/bin/perl

use strict;
use FDN::Web::Array;
use FDN::Adsl::Adhs;
use FDN::Adsl::Basic;

prepare_page_adh(only_for_adh => 1);

my $page = '<h1>Souscription</h1><p>Souscrire <a href="/adherents/adh-subvpn.cgi?sess=%%sess%%">un abonnement VPN</a></p>';
$page .= "\n<h1>Abonnements</h1>\n";
my $cid = $sess->{content}->{cid};
my @vpns = vpn_par_client_id($cid);
for my $v ( @vpns ) {
	my $vid = $v->{'VPN_ID'};
	my $rad = raduser_par_vpn_id($vid);
	$v->{'login'} = $rad->{'RADUSER_LOGIN'};
	my $uattrs = [ uattr_par_raduser_id($rad->{'RADUSER_ID'}) ];
	for my $ua ( @$uattrs ) {
		$v->{'passwd'} = $ua->{'UATTR_VALUE'} if $ua->{'UATTR_ATTR'} =~ /Passw/;
		$v->{'ipaddr'} = $ua->{'UATTR_VALUE'} if $ua->{'UATTR_ATTR'} =~ /IP-Address/;
		$v->{'ip6addr'} = $ua->{'UATTR_VALUE'} if $ua->{'UATTR_ATTR'} =~ /IPv6-Address/;
		$v->{'ip6route'} = $ua->{'UATTR_VALUE'} if $ua->{'UATTR_ATTR'} =~ /IPv6-Route/;
	}

	my $name;
	if ( $v->{'VPN_STATE'} eq 'new' ) {
		$name = 'VPN en attente (<a href="adh-valvpn.cgi?sess=%%sess%%&vid='.$vid.'">Valider</a> <a href="adh-resvpn.cgi?sess=%%sess%%&vid='.$vid.'">Rsilier</a>)';
	} elsif ( $v->{'VPN_STATE'} eq 'ok' ) {
		$name = 'VPN '.$v->{'ipaddr'}.' (<a href="adh-resvpn.cgi?sess=%%sess%%&vid='.$vid.'">Rsilier</a>)';
	} elsif ( $v->{'VPN_STATE'} eq 'del' ) {
		$name = 'VPN rsili';
	} else {
		$name = 'VPN en attente';
	}

	$page .= tableau_1d('adsl/adhs/rewrite.tbl','vpn',$v,$name);
}

if ( $#vpns == -1 ) {
	$page .= "<p>Vous n'avez pas souscrit d'abonnement VPN FDN</p>";
}
$page .= "<p>Cette page ne prsente que les abonnements VPN, pas les autres abonnements.".
	 "</p>";
eject_page_adh($page);


