#!/usr/bin/perl

use strict;
use FDN::Common::Config;
use FDN::Web::Array;
use FDN::Adsl::Adhs;
use FDN::Adsl::Basic;
use FDN::Adsl::Utils;

prepare_page_adh();
my $page = '';
my $cid = $sess->{content}->{cid};

my $type = $vars->{'type'};
my $dir  = $vars->{'dir'};
my $doc  = $vars->{'doc'};

if ( $type eq 'access' ) {
	my ( $login, $other );
	if ( $dir =~ /^adhacc-$cid(\/([^\/]*))?$/ ) {
		$login = $1;
		$other = $3;
	} else {
		eject_page_adh('Permission denied');
		exit(0);
	}
	if ( $doc =~ /\// ) {
		eject_page_adh('Permission denied');
		exit(0);
	}
#	my $access = adhaccess_par_login($login);
#	if ( $access->{'CLIENT_ID'} ne $cid ) {
#		eject_page_adh('Permission denied');
#		exit(0);
#	}
	if ( $other ) {
		if ( $other !~ /prel(\d+)$/ ) {
			eject_page_adh('Permission denied');
			exit(0);
		}
		my $prel = prelevemt_par_id($1);
		if ( ! $prel || $prel->{'CLIENT_ID'} != $cid ) {
			eject_page_adh('Permission denied');
			exit(0);
		}
	}
} elsif ( $type eq 'ligne' ) {
	my $depl = deploiement_par_num($dir);
	my $lid = $depl->{'LIGNE_ID'};
	my $ligne = ligne_par_id($lid);
	if ( ! defined $ligne ) {
		eject_page_adh('Permission denied');
		exit(0);
	}
	if ( $ligne->{'CLIENT_ID'} ne $cid ) {
		eject_page_adh('Permission denied');
		exit(0);
	}
} elsif ( $type eq 'vpn' ) {
	my $depl = deploiement_par_num($dir);
	my $lid = $depl->{'VPN_ID'};
	my $vpn = vpn_par_id($lid);
	if ( ! defined $vpn ) {
		eject_page_adh('Permission denied');
		exit(0);
	}
	if ( $vpn->{'CLIENT_ID'} ne $cid ) {
		eject_page_adh('Permission denied');
		exit(0);
	}
} else {
	eject_page_adh('Permission denied');
	exit(0);
}

my $base = Config_Key('adsl/global.cfg','dirs','stockpdf');
my $file = $base.'/'.$dir.'/'.$doc;
if ( ! -f $file ) {
	eject_page_adh("File not found: $file");
} else {
	send_pdf_file($file);
}
